;LAST MODIFIED 01/07/89
createlib "mainlib"
cursor off
style reverse
@ 24,61 ?? " Compiling code"
style reverse, blink
?? "... "
;===================================================================================================================================
proc win(rownum,colnum,attrib)
 private stringsize,key,counter,linecounter,i

  array linecounter[arraysize(choicearray)]       ;INITIALIZE ARRAY FOR LINE COUNTER
  for counter from 1 to arraysize(linecounter)    ;LOAD LINECOUNTER ARRAY WITH ROW NUMBERS
    linecounter[counter] = rownum + 1
    rownum = rownum + 1
  endfor

  stringsize = len(choicearray[1])                ;PRIME THE FOR LOOP
  for counter from 2 to arraysize(choicearray)    ;DETERMINE STRLEN OF LARGEST CHOICE
    if (len(choicearray[counter]) > stringsize) then
      stringsize = len(choicearray[counter])
    endif
  endfor

  attrib = "w" + strval(stringsize) + "," + attrib ;PLACE BOX ON SCREN
  @ linecounter[1] - 1,colnum ?? "" + fill("",stringsize) + ""
  for counter from 1 to arraysize(linecounter)
    @ linecounter[counter],colnum ?? "" + format(attrib,choicearray[counter]) + ""
  endfor
  @ rownum + 1,colnum ?? "" + fill("",stringsize) + ""

  style reverse                                   ;PLACE FIRST MENU CHOICE
  @ linecounter[1],colnum + 1 ?? format(attrib,choicearray[1])

  counter = 1
  while (true)
    key = getchar()                            ;CATCH A KEY
    style                                      ;TURN OFF CURRENT CHOICE
    @linecounter[counter],colnum + 1 ?? format(attrib,choicearray[counter])
    switch
      case key > 64 and key < 123: for i from 1 to arraysize(choicearray)
                                     if (match(choicearray[i]," " + chr(key) + "..")) then
                                       counter = i
                                       quitloop
                                     endif
                                   endfor
      case key = -59 : cursor normal        ;[F1] KEY
                       style reverse
                       @24,0
                       ?? "Working Directory: "
                       accept "A30" required to dirname
                       if (retval) then
                         if (direxists(dirname) = 1) then
                           setdir(dirname)
                         else
                           beep
                           messenger("No such directory",2)
                         endif
                       endif

                       cursor off
      case key = -80 : if (counter = arraysize(choicearray)) then   ;DOWN KEY
                         counter = 0
                       endif
                       counter = counter + 1
      case key = -72 : if (counter = 1) then   ;UP KEY
                         counter = arraysize(choicearray) + 1
                       endif
                       counter = counter - 1
      case key = 13  : switch                  ;ENTER KEY
                         case counter = 1  : choice1()
                         case counter = 2  : choice2()
                         case counter = 3  : choice3()
                         case counter = 4  : choice4()
                         case counter = 5  : choice5()
                         case counter = 6  : choice6()
                         case counter = 7  : choice7()
                         case counter = 8  : choice8()
                         case counter = 9  : choice9()
                         case counter = 10 : choice10()
                         case counter = 11 : choice11()
                         case counter = 12 : choice12()
                         case counter = 13 : choice13()
                         case counter = 14 : choice14()
                         case counter = 15 : choice15()
                         case counter = 16 : choice16()
                         case counter = 17 : choice17()
                         case counter = 18 : choice18()
                         case counter = 19 : choice19()
                       endswitch
      case key = -60 : message "Thanks for using the PARADOX X-TENDER!"
                       sleep 2000
                       quitloop
      otherwise      : beep
    endswitch
    style reverse                              ;PLACE NEW CHOICE
    @ 24,0 ?? format("w80,al","Working Directory: " + upper(directory()))
    @linecounter[counter],colnum + 1 ?? format(attrib,choicearray[counter])
  endwhile
endproc

writelib "mainlib" win
release procs win
;===================================================================================================================================
proc error()
 private errorproc,key
  cursor off
  style attribute 79
  beep beep beep beep beep beep
  @ 9,25 ?? "ͻ"
  @10,25 ?? " ! F A T A L  E R R O R ! "
  @11,25 ?? "      Please contact      "
  @12,25 ?? "     TEKNIKA SOFTWARE     "
  @13,25 ?? "      for assistance      "
  @14,25 ?? "    any key to continue   "
  @15,25 ?? "ͼ"
  key = getchar()
  quit
endproc

writelib "mainlib" error
release procs error
;===================================================================================================================================
proc messenger(msg,secs)
  cursor off
  style reverse
  @ 24,(76 - len(" " + msg))
  ?? " " + msg                              ;PLACE THE MESSAGE
  style reverse,blink
  ?? "... "
  sleep (secs * 1000)
endproc

writelib "mainlib" messenger
release procs messenger
;===================================================================================================================================
proc wrongans(choice)
  cursor off
  switch
    case choice = 1 : choice = "    NO SUCH TABLE"
    case choice = 2 : choice = "    NO SUCH FIELD"
    case choice = 3 : choice = "                 "
    case choice = 4 : choice = "          TOO LOW"
    case choice = 5 : choice = "         TOO HIGH"
    case choice = 6 : choice = "PAGE 1 ONLY AFTER"
    case choice = 7 : choice = "MORE THAN 1 FIELD"
    case choice = 8 : choice = " WRONG FIELD TYPE"
    case choice = 9 : choice = " INVALID PASSWORD"
    case choice = 10: choice = " LIKE ABOVE FIELD"
    case choice = 11: choice = "    REPORT EXISTS"
  endswitch
  style reverse
  @ 24,(80 - len(choice + " "))
  ?? choice + " "
  cursor normal
endproc

writelib "mainlib" wrongans
release procs wrongans
;===================================================================================================================================
proc getftype()
  if (sysmode() = "Edit") then
    execute "ftype = substr(type([" + tablename + "->" + fieldname + "]),1,1)" ;GET FIELD TYPE
  else                                    ;IN CASE YOU'RE IN ASK MODE
    moveto field fieldname
    ftype = substr(fieldtype(),1,1)
  endif
endproc

writelib "mainlib" getftype
release procs getftype
;===================================================================================================================================
proc verifytable(x,y)
  @ x,y                                           ;PLACE CURSOR
  accept "A8" required to tablename
  if (retval) then                                ;IF USER DIDN'T PRESS [ESC]
    while ((not istable(tablename)) and (retval)) ;WHILE TABLE DOESN'T EXIST AND USER DOESN'T PRESS [ESC]
      beep
      wrongans(1)                                 ;PLACE ERROR MESSAGE
      @ x,y
      accept "A8" required to tablename
    endwhile
  endif
  wrongans(3)                                     ;ERASE ANY ERROR MESSAGE
endproc                                           ;RETVAL = TRUE IF USER DIDN'T PRESS [ESC] AND TABLE EXISTS

writelib "mainlib" verifytable
release procs verifytable
;===================================================================================================================================
proc verifyfield(x,y,ft)
 private fieldname,validfield,ftype
  @ x,y                                       ;PLACE THE CURSOR
  accept "A25" required to fieldname
  if (retval) then                            ;IF USER DIDN'T PRESS [ESC]
    validfield = fieldno(fieldname,tablename) ;CHECK FOR EXISTANCE OF FIELD
    if (validfield <> "Error") then           ;IF A VALID FIELD
      getftype()
    endif
    while ((validfield = "Error" or ftype <> ft) and retval) ;WHILE FIELD IS NO GOOD
      beep
      if (fieldno(fieldname,tablename) = "Error") then
        wrongans(2)
      else
        wrongans(8)
      endif
      @ x,y
      accept "A25" required to fieldname
      wrongans(3)
      validfield = fieldno(fieldname,tablename)
      if (validfield <> "Error") then
        getftype()
      endif
    endwhile
  endif
  if (not retval) then                      ;IF USER PRESSED [ESC] AT THIS POINT, FIELDNAME NOT ASSIGNED, SO ASSIGN IT A VALUE
    continue = false
    fieldname = ""
    if (sysmode() = "Edit") then            ;IN CASE YOU'RE DOING AN ASK
      canceledit
    endif
  else                                      ;USER DIDN'T PRESS [ESC], FIELDNAME WAS ASSIGNED IN UPPER WHILE LOOP
    continue = true
  endif
  return fieldname
endproc

writelib "mainlib" verifyfield
release procs verifyfield
;===================================================================================================================================
proc verifytwofields(x,y,ft1,ft2)
 private fieldname,validfield,ftype
  @ x,y                                       ;PLACE THE CURSOR
  accept "A25" required to fieldname
  if (retval) then                            ;IF USER DIDN'T PRESS [ESC]
    validfield = fieldno(fieldname,tablename) ;CHECK FOR EXISTANCE OF FIELD
    if (validfield <> "Error") then           ;IF A VALID FIELD
      getftype()
    endif
    while ((validfield = "Error" or (ftype <> ft1 and ftype <> ft2)) and retval) ;WHILE FIELD IS NO GOOD
      beep
      if (fieldno(fieldname,tablename) = "Error") then
        wrongans(2)
      else
        wrongans(8)
      endif
      @ x,y
      accept "A25" required to fieldname
      wrongans(3)
      validfield = fieldno(fieldname,tablename)
      if (validfield <> "Error") then
        getftype()
      endif
    endwhile
  endif
  if (not retval) then                      ;IF USER PRESSED [ESC] AT THIS POINT, FIELDNAME NOT ASSIGNED, SO ASSIGN IT A VALUE
    continue = false
    fieldname = ""
    if (sysmode() = "Edit") then            ;IN CASE YOU'RE DOING AN ASK
      canceledit
    endif
  else                                      ;USER DIDN'T PRESS [ESC], FIELDNAME WAS ASSIGNED IN UPPER WHILE LOOP
    continue = true
  endif
  return fieldname
endproc

writelib "mainlib" verifytwofields
release procs verifytwofields
;===================================================================================================================================
proc ckpass()
 private key

  key = 0
  pwordvar = ""

  beep beep
  @24,48 ?? "ENTER PASSWORD: ..............."
  @24,64
  while (key <> 13)
    key = getchar()
    if (col() = 79 and key <> 13 and key <> 27 and key <> 8) then
      beep
      @24,79
    else
      switch
        case key < 1 : beep
        case key = 8 : if (col() <> 64) then
                         @24,col() - 1
                         ?? "."
                         @24,col() - 1
                         pwordvar = substr(pwordvar,1,len(pwordvar) - 1)
                        else
                          beep
                        endif
        case key = 13 : quitloop
        case key = 27 : retval = false
                        quitloop
      endswitch
      if (key <> 8 and key > 0) then
        pwordvar = pwordvar + chr(key)
        ?? "*"
      endif
    endif
  endwhile
  @24,48 ?? "                               "

  if (retval) then                     ;IF USER DIDN'T PRESS [ESC]
    typein pwordvar enter
    if (substr(window(),1,7) = "Invalid") then
      beep
      messenger("Invalid password",2)
      menu                             ;RETURN TO PARADOX MAIN MENU
      retval = false
      return
    endif
  else
    menu                               ;RETURN TO PARADOX MAIN MENU
    if (sysmode() = "Edit") then
      canceledit
    endif
    return
  endif
endproc

writelib "mainlib" ckpass
release procs ckpass
;===================================================================================================================================
proc break()
 private first,last
  moveto field fieldname1
  scan
    if (match([],".. ..",first,last)) then
      execute "[" + fieldname2 + "] = \"" + first + "\""
      execute "[" + fieldname3 + "] = \"" + last + "\""
    else
      execute "[" + fieldname2 + "] = []"   ;TWO VALUES NOT FOUND, JUST PLACE SINGLE VALUE IN FIRST FIELD
    endif
  endscan
  do_it!
endproc

writelib "mainlib" break
release procs break
;===================================================================================================================================
proc firstup()
  moveto field fieldname
  scan
    [] = format("cc",[])
  endscan
  do_it!
endproc

writelib "mainlib" firstup
release procs firstup
;===================================================================================================================================
proc greplace()
 private textbegin,textend
  moveto field fieldname
  scan for (match([],".." + oldvalue + "..",textbegin,textend))
    [] = textbegin + newvalue + textend
  endscan
  do_it!
endproc

writelib "mainlib" greplace
release procs greplace
;===================================================================================================================================
proc incnum()
  moveto field fieldname
  if (fieldtype() = "N") then
    scan
      [] = startnum
     startnum = startnum + incrementor
    endscan
  else                                    ;FIELD IS ALPHANUMERIC
    scan
      [] = strval(startnum)
      startnum = startnum + incrementor
    endscan
  endif
  do_it!
endproc

writelib "mainlib" incnum
release procs incnum
;===================================================================================================================================
proc insrec(tablename,recnum,times,before)
 private a,i
  moveto record recnum
  copytoarray a                             ;COPY RECORD TO TEMP ARRAY
  if (before > nrecords(tablename)) then
    end
    down
  else
    moveto record before                    ;MOVE TO INSERTION POINT
  endif
  for i from 1 to times
    ins
    copyfromarray a
  endfor
  do_it!
endproc

writelib "mainlib" insrec
release procs insrec
;===================================================================================================================================
proc lowcase()
  moveto field fieldname
  scan
    [] = lower([])
  endscan
  do_it!
endproc

writelib "mainlib" lowcase
release procs lowcase
;===================================================================================================================================
proc qnum()
 private i, temprec
  create "answer" like tablename
  view "answer"
    editkey                                   ;PUT BOTH TABLES IN EDIT
    upimage                                   ;MOVE BACK TO ORIGINAL TABLE
    moveto record beginrec
    for i from beginrec to endrec
      copytoarray temprec
      down
      downimage
      copyfromarray temprec
      down
      upimage
    endfor
  do_it!
endproc

writelib "mainlib" qnum
release procs qnum
;===================================================================================================================================
proc upcase()
  moveto field fieldname
  scan
    [] = upper([])
  endscan
  do_it!
endproc

writelib "mainlib" upcase
release procs upcase
;===================================================================================================================================
proc wswitch()
 private firstword, secondword
  moveto field fieldname
  scan for match([],".. ..",firstword,secondword)  ;ONLY TOUCH IF 2 WORDS FOUND
    [] = secondword + " " + firstword
    firstword = ""
    secondword = ""
  endscan
  do_it!
endproc

writelib "mainlib" wswitch
release procs wswitch
;===================================================================================================================================
proc dateconv()
  scan
    execute "[" + fieldname2 + "] = format(\"D2\",[" + fieldname1 + "])"
  endscan
  do_it!
endproc

writelib "mainlib" dateconv
release procs dateconv
;===================================================================================================================================
proc fjulian()
  moveto field fieldname1
  example "a"
  moveto field fieldname2
  "changeto (1/1/00 + " example "a) - 2"
  do_it!
  delete "changed"
endproc

writelib "mainlib" fjulian
release procs fjulian
;===================================================================================================================================
proc tjulian()
  moveto field fieldname1
  example "a"
  moveto field fieldname2
  "changeto (" example "a - 1/1/00) + 2"
  do_it!
  delete "changed"
endproc

writelib "mainlib" tjulian
release procs tjulian
;===================================================================================================================================
proc lastdown()
  moveto field fieldname
  scan
    [] = format("cc",(lower([])))
  endscan
  do_it!
endproc

writelib "mainlib" lastdown
release procs lastdown
;===================================================================================================================================
proc recsize()
 private char,counter,recsize,width
  recsize = 0
  scan
    char = substr([Field Type],1,1)
    switch
      case char = "N" : counter = 8
      case char = "$" : counter = 8
      case char = "D" : counter = 4
      case char = "S" : counter = 2
      case char = "A" : switch
                          case (match([Field Type],"A..*",width)) :
                          case (match([Field Type],"A..",width))  :
                        endswitch
                        counter = numval(width)
    endswitch
    recsize = recsize + counter
  endscan
  return recsize
endproc

writelib "mainlib" recsize
release procs recsize
;===================================================================================================================================
proc stateabv()
 private statename,abv
  moveto field fieldname1
  scan
    statename = upper([])
    switch
      case statename = "ALABAMA"              : abv = "AL"
      case statename = "ALASKA"               : abv = "AK"
      case statename = "ARIZONA"              : abv = "AZ"
      case statename = "CALIFORNIA"           : abv = "CA"
      case statename = "COLORADO"             : abv = "CO"
      case statename = "CONNECTICUT"          : abv = "CT"
      case statename = "DELAWARE"             : abv = "DE"
      case statename = "DISTRICT OF COLUMBIA" : abv = "DC"
      case statename = "FLORIDA"              : abv = "FL"
      case statename = "GEORGIA"              : abv = "GA"
      case statename = "HAWAII"               : abv = "HI"
      case statename = "IDAHO"                : abv = "ID"
      case statename = "ILLINOIS"             : abv = "IL"
      case statename = "INDIANA"              : abv = "IN"
      case statename = "IOWA"                 : abv = "IA"
      case statename = "KANSAS"               : abv = "KS"
      case statename = "KENTUCKY"             : abv = "KY"
      case statename = "LOUISIANA"            : abv = "LA"
      case statename = "MAINE"                : abv = "ME"
      case statename = "MARYLAND"             : abv = "MD"
      case statename = "MASSACHUSETTS"        : abv = "MA"
      case statename = "MICHIGAN"             : abv = "MI"
      case statename = "MINNESOTA"            : abv = "MN"
      case statename = "MISSISSIPPI"          : abv = "MS"
      case statename = "MISSOURI"             : abv = "MO"
      case statename = "MONTANA"              : abv = "MT"
      case statename = "NEBRASKA"             : abv = "NE"
      case statename = "NEVEDA"               : abv = "NV"
      case statename = "NEW HAMPSHIRE"        : abv = "NH"
      case statename = "NEW JERSEY"           : abv = "NJ"
      case statename = "NEW MEXICO"           : abv = "NM"
      case statename = "NEW YORK"             : abv = "NY"
      case statename = "NORTH CAROLINA"       : abv = "NC"
      case statename = "NORTH DAKOTA"         : abv = "ND"
      case statename = "OHIO"                 : abv = "OH"
      case statename = "OKLAHOMA"             : abv = "OK"
      case statename = "OREGON"               : abv = "OR"
      case statename = "PENNSYLVANIA"         : abv = "PA"
      case statename = "PUERTO RICO"          : abv = "PR"
      case statename = "RHODE ISLAND"         : abv = "RI"
      case statename = "SOUTH CAROLINA"       : abv = "SC"
      case statename = "SOUTH DAKOTA"         : abv = "SD"
      case statename = "TENNESSEE"            : abv = "TN"
      case statename = "TEXAS"                : abv = "TX"
      case statename = "UTAH"                 : abv = "UT"
      case statename = "VERMONT"              : abv = "VT"
      case statename = "VIRGINIA"             : abv = "VA"
      case statename = "WASHINGTON"           : abv = "WA"
      case statename = "WEST VIRGINIA"        : abv = "WV"
      case statename = "WISCONSIN"            : abv = "WI"
      case statename = "WYOMING"              : abv = "WY"
      otherwise                               : abv = ""
    endswitch
    execute "[" + fieldname2 + "] = \"" + abv + "\""
  endscan
  do_it!
endproc

writelib "mainlib" stateabv
release procs stateabv
;===================================================================================================================================
proc stateful()
 private statename, abv
  moveto field fieldname2
  scan
    abv = upper([])
    switch
      case abv = "AL" : statename = "ALABAMA"
      case abv = "AK" : statename = "ALASKA"
      case abv = "AZ" : statename = "ARIZONA"
      case abv = "CA" : statename = "CALIFORNIA"
      case abv = "CO" : statename = "COLORADO"
      case abv = "CT" : statename = "CONNECTICUT"
      case abv = "DE" : statename = "DELAWARE"
      case abv = "DC" : statename = "DISTRICT OF COLUMBIA"
      case abv = "FL" : statename = "FLORIDA"
      case abv = "GA" : statename = "GEORGIA"
      case abv = "HI" : statename = "HAWAII"
      case abv = "ID" : statename = "IDAHO"
      case abv = "IL" : statename = "ILLINOIS"
      case abv = "IN" : statename = "INDIANA"
      case abv = "IA" : statename = "IOWA"
      case abv = "KS" : statename = "KANSAS"
      case abv = "KY" : statename = "KENTUCKY"
      case abv = "LA" : statename = "LOUISIANA"
      case abv = "ME" : statename = "MAINE"
      case abv = "MD" : statename = "MARYLAND"
      case abv = "MA" : statename = "MASSACHUSETTS"
      case abv = "MI" : statename = "MICHIGAN"
      case abv = "MN" : statename = "MINNESOTA"
      case abv = "MS" : statename = "MISSISSIPPI"
      case abv = "MO" : statename = "MISSOURI"
      case abv = "MT" : statename = "MONTANA"
      case abv = "NE" : statename = "NEBRASKA"
      case abv = "NV" : statename = "NEVEDA"
      case abv = "NH" : statename = "NEW HAMPSHIRE"
      case abv = "NJ" : statename = "NEW JERSEY"
      case abv = "NM" : statename = "NEW MEXICO"
      case abv = "NY" : statename = "NEW YORK"
      case abv = "NC" : statename = "NORTH CAROLINA"
      case abv = "ND" : statename = "NORTH DAKOTA"
      case abv = "OH" : statename = "OHIO"
      case abv = "OK" : statename = "OKLAHOMA"
      case abv = "OR" : statename = "OREGON"
      case abv = "PA" : statename = "PENNSYLVANIA"
      case abv = "PR" : statename = "PUERTO RICO"
      case abv = "RI" : statename = "RHODE ISLAND"
      case abv = "SC" : statename = "SOUTH CAROLINA"
      case abv = "SD" : statename = "SOUTH DAKOTA"
      case abv = "TN" : statename = "TENNESSEE"
      case abv = "TX" : statename = "TEXAS"
      case abv = "UT" : statename = "UTAH"
      case abv = "VT" : statename = "VERMONT"
      case abv = "VA" : statename = "VIRGINIA"
      case abv = "WA" : statename = "WASHINGTON"
      case abv = "WV" : statename = "WEST VIRGINIA"
      case abv = "WI" : statename = "WISCONSIN"
      case abv = "WY" : statename = "WYOMING"
      otherwise       : statename = ""
    endswitch
    execute "[" + fieldname1 + "] = \"" + statename + "\""
  endscan
  do_it!
endproc

writelib "mainlib" stateful
release procs stateful
;===================================================================================================================================
proc dollars()
 private amountlength, i, nval, dstring, ones, tens, cents, status

  array ones[19]
  ones[1] = "One"        ones[2] = "Two"
  ones[3] = "Three"      ones[4] = "Four"
  ones[5] = "Five"       ones[6] = "Six"
  ones[7] = "Seven"      ones[8] = "Eight"
  ones[9] = "Nine"       ones[10] = "Ten"
  ones[11] = "Eleven"    ones[12] = "Twelve"
  ones[13] = "Thirteen"  ones[14] = "Fourteen"
  ones[15] = "Fifteen"   ones[16] = "Sixteen"
  ones[17] = "Seventeen" ones[18] = "Eighteen"
  ones[19] = "Ninteen"

  array tens[9]
  tens[1] = ""
  tens[2] = "Twenty"
  tens[3] = "Thirty"
  tens[4] = "Forty"
  tens[5] = "Fifty"
  tens[6] = "Sixty"
  tens[7] = "Seventy"
  tens[8] = "Eigthy"
  tens[9] = "Ninety"

  moveto field fieldname1
  scan
    amountlength = len(strval([])) - 3
    cents = substr([],search(".",[]) + 1,2)
    amount = substr([],1,amountlength)
    dstring = ""
    for i from 1 to amountlength
      nval = numval(substr(amount,i,1))
      if (nval <> 0) then
        switch
          case ((amountlength + 1) - i = 1) :
            dstring = dstring + " " + ones[nval]
          case ((amountlength + 1) - i = 2) :
            if (nval = 1) then
              nval = numval(substr(amount,amountlength,1))
              dstring = dstring + " " + ones[nval + 10]
              quitloop
            else
              dstring = dstring + " " + tens[nval]
            endif
          case ((amountlength + 1) - i = 3) :
            dstring = dstring + " " + ones[nval] + " Hundred"
          case ((amountlength + 1) - i = 4) :
            dstring = dstring + " " + ones[nval] + " Thousand"
          case ((amountlength + 1) - i = 5) :
            if (numval(substr(amount,(amountlength - 3),1)) = 0) then
              if (nval = 1) then
                nval = numval(strval(nval) + strval(0))
                dstring = dstring + " " + ones[nval] + " Thousand"
              else
                dstring = dstring + " " + tens[nval] + " Thousand"
              endif
            else if (nval = 1) then
                   nval = numval(strval(nval) + substr(amount,(amountlength - 3),1))
                   dstring = dstring + " " + ones[nval] + " Thousand"
                   i = i + 1
                 else
                 dstring = dstring + " " + tens[nval]
               endif
            endif
          case ((amountlength + 1) - i = 6) :
            if (numval(substr(amount,(amountlength - 4),1)) = 0) then
              if (numval(substr(amount,(amountlength - 3),1)) = 0) then
                dstring = dstring + " " + ones[nval] + " Hundred Thousand"
              else
                dstring = dstring + " " + ones[nval] + " Hundred"
              endif
            else
              dstring = dstring + " " + ones[nval] + " Hundred"
            endif
          case ((amountlength + 1) - i = 7) :
            dstring = dstring + " " + ones[nval] + " Million"
          case ((amountlength + 1) - i = 8) :
            if (numval(substr(amount,(amountlength - 6),1)) = 0) then
              if (nval = 1) then
                nval = numval(strval(nval) + strval(0))
                dstring = dstring + " " + ones[nval] + " Million"
              else
                dstring = dstring + " " + tens[nval] + " Million"
              endif
            else if (nval = 1) then
                   nval = numval(strval(nval) + substr(amount,(amountlength - 6),1))
                   dstring = dstring + " " + ones[nval] + " Million"
                   i = i + 1
                 else
                   dstring = dstring + " " + tens[nval]
                 endif
            endif
          case ((amountlength + 1) - i = 9) :
            if (numval(substr(amount,(amountlength - 7),1)) = 0) then
              if (numval(substr(amount,(amountlength - 6),1)) = 0) then
                dstring = dstring + " " + ones[nval] + " Hundred Million"
              else
                dstring = dstring + " " + ones[nval] + " Hundred"
              endif
            else
              dstring = dstring + ones[nval] + " Hundred"
            endif
        endswitch
      endif
    endfor
    status = match(dstring," ..",dstring)   ;STRIP OFF LEADING SPACE
    dstring = dstring + " and " + cents + "/100 Dollars"
    execute "[" + fieldname2 + "] = \"" + dstring + "\""
  endscan
  do_it!
endproc

writelib "mainlib" dollars
release procs dollars
;===================================================================================================================================
proc formcopy()
 private line,holder,begincolumn,endcolumn,linenumber,status,typeoffield,fieldname

  array holder[23]                             ;INITIALIZE
  begincolumn = 0

  select formnumber
  enter                                        ;FOR DESCRIPTION

  if (numval(page) > npages()) then            ;CHECK FOR NON-EXISTANT PAGE
    menu {cancel} {yes}
    beep
    messenger("Page doesn't exist",2)
  else
    for line from 1 to 23                      ;23 LINES ON FORM PAGE
      holder[line]=cursorline()                ;COPY LINE CONTENTS TO ARRAY
      if (begincolumn = 0) then                ;SEARCH FOR A FIELD - CHECK FOR FIELD ONLY ONCE
        begincolumn = search("_",holder[line]) ;GET STARTING COLUMN
        if (begincolumn > 0) then              ;IF FIELD WAS FOUND
          linenumber = line                    ;GET LINE NUMBER
          while (colno() <> begincolumn)       ;MOVE OVER TO THE FIELD
            right
          endwhile
          status = match(fieldinfo(),"..,..",typeoffield,fieldname) ;GET FIELD NAME
          if (isassigned(typeoffield)) then      ;MAKE SURE IT'S *NOT* RECORDNUMBER FIELD
            while (cursorchar() = "_")           ;MOVE TO END OF PLACED FIELD
              right
            endwhile
            endcolumn = colno()                  ;GET LENGTH OF PLACED FIELD
            menu {field} {erase} left enter      ;CURSOR IS ON FIELD, NOW ERASE
            ctrlhome
          else
            begincolumn = 0                      ;REGULAR, CALC OR DISPLAY FIELD NOT FOUND, KEEP SEARCHING
          endif
        endif
      endif
      down
    endfor

    menu {page} {insert} select where       ;CREATE A NEW PAGE
    for line from 1 to 23
      typein holder[line]                   ;INSERT NEW LINES
      if (line = linenumber) then           ;IS THIS A LINE WITH THE FIELD?
        while (colno() <> begincolumn)      ;MOVE OVER TO THE BEGINNING COL
            right
        endwhile
        menu {field} {place} {regular} select fieldname
        enter                               ;PLACE BEGINNING OF FIELD
        while (colno() > (endcolumn - 1))   ;ADJUST THE FIELD WIDTH
          left
        endwhile
        enter                               ;FINISH FIELD PLACEMENT
        if (formnumber = "F") then          ;IF FIELD PLACED AT FULL LENGTH, GET RID OF TRAILING "_" WITH A SPACE
          keypress 32                       ;  STANDARD FORMS HAVE ALL FIELDS PLACED WITH A EXTRA PLACE AT END
        endif
        ctrlhome                            ;GO TO 1ST COL
      endif
      down
    endfor
  endif
  do_it!
  if (substr(window(),1,4) = "Page") then   ;THERE ARE NO REGULAR FIELDS TO BE PLACED!
    menu {cancel} {yes}
    beep
    messenger("No regular fields to place",2)
    messenger("                          ",0)
  endif
endproc

writelib "mainlib" formcopy
release procs formcopy
;===================================================================================================================================
proc formrept()
 private i,j,totalpages,totallines,totalfields,lineholder,numfieldsperline,fieldbegin,pagecounter,toppagecounter,botpagecounter,
         linecounter,startposition,fieldsperlinecounter,beginfieldposition,status,typeoffield,fieldname,wrapnumber,fieldlength,
         nameoffield,fieldcounter,counter,wrap

  select formnumber                         ;CHOOSE THE FORM
  enter                                     ;FOR THE DESCRIPTION

  totalpages = npages()
  totallines = totalpages * 23
  totalfields = nfields(tablename) + 15     ;ADD 15 FOR EXTRA CALC FIELDS
  botpagecounter = 0                        ;COUNTER FOR COUNTING ALL TOTAL LINES
  fieldcounter = 0                          ;COUNTER FOR ALL FIELDS
  wrap = ""                                 ;INTIALIZE WRAP VARIABLE

  array lineholder[totallines]              ;ARRAY TO HOLD EVERY LINE
  array numfieldsperline[totallines]        ;ARRAY TO STORE NUMBER OF FIELDS PER LINE
  array fieldname[totalfields]              ;ARRAY TO STORE NAME OF FIELD
  array fieldbegin[totalfields]             ;ARRAY TO STORE STARTING POSITION OF A FIELD
  array fieldlength[totalfields]            ;ARRAY TO STORE LENGTH OF EACH FIELD

  for pagecounter from 1 to totalpages                      ;COUNT FROM PAGE TO PAGE
    toppagecounter = botpagecounter + 1                     ;1,24,47 - TOP OF EACH PAGE
    botpagecounter = botpagecounter + 23                    ;23,46,69 - BOTTOM OF EACH PAGE
      for linecounter from toppagecounter to botpagecounter ;COUNT WITHIN EACH PAGE BY LINE
        lineholder[linecounter] = cursorline()              ;COPY CONTENTS OF ENTIRE LINE TO ARRAY
        startposition = search("_",lineholder[linecounter]) ;FIND A FIELD ON THIS LINE
        fieldsperlinecounter = 0                            ;RESET TO ZERO
        while (startposition <> 0)                          ;WHILE A FIELD WAS FOUND
          fieldcounter = fieldcounter + 1
          fieldsperlinecounter = fieldsperlinecounter + 1
          numfieldsperline[linecounter] = fieldsperlinecounter  ;KEEP TRACK OF FIELDS PER LINE
          while (colno() <> startposition)                      ;MOVE OVER TO THE FIRST "_" IN THE FIELD
            right
          endwhile
          fieldname[fieldcounter] = fieldinfo()                 ;COPY NAME OF FIELD TO ARRAY
          beginfieldposition = colno()                          ;GET BEGINNING FIELD POSITION
          fieldbegin[fieldcounter] = beginfieldposition ;ASSIGN COL POSITION OF FIELD TO ARRAY
          while (cursorchar() = "_")                            ;FIND THE END OF THE FIELD
            right
          endwhile
          fieldlength[fieldcounter] = colno() - beginfieldposition
          startposition = search("_",substr(lineholder[linecounter],colno(),80 - colno())) ;LOOK FOR NEXT FIELD
          if (startposition <> 0) then                          ;IF STARTPOSITION FOUND, IT'S "VIRTUAl," SO ADD
            startposition = (colno() - 1) + startposition       ;  COLNO() TO IT
          endif
        endwhile
        ctrlhome                            ;GO BACK TO COL 1
        down                                ;GO DOWN TO NEXT LINE
      endfor
      pgdn                                  ;FINISHED WITH 23 LINES, GO TO NEXT PAGE
  endfor
  menu {cancel} {yes}                       ;CLOSE UP THE FORM

  {report} {design} select tablename select reportnumber enter {free-form} ;CREATE THE REPORT
  menu {setting} {pagelayout} {width} ctrlbackspace typein "255" enter     ;IN CASE WORD WRAP ALPHA FIELDS EXCEED 80 COLS
  ctrlhome                                                                 ;MOVE CURSOR BACK TO COL 1

  for linecounter from 1 to 9               ;MOVE DOWN TO THE TABLE BAND
    down
  endfor
  totalfields = nfields(tablename) + 1      ;1 EXTRA FOR FIRST BLANK LINE
  for linecounter from 1 to totalfields     ;DELETE THE FIELDS ALREADY THERE
    deleteline
  endfor
  ins                                       ;TURN INSERT ON
  fieldcounter = 0
  for linecounter from 1 to totallines      ;LOOP THRU EVERY LINE
    typein lineholder[linecounter]
    if (isassigned(numfieldsperline[linecounter])) then                        ;IF THIS LINE HAS FIELDS
      fieldcounter = numfieldsperline[linecounter] + fieldcounter              ;MAINTAIN A MASTER FIELD COUNTER
      counter = fieldcounter                                                   ;DECREMENT "COUNTER" FOR FIELD COUNTER
      for fieldsperlinecounter from numfieldsperline[linecounter] to 1 step -1 ;PLACE THE FIELDS ON THIS LINE
        while (colno() <> fieldbegin[counter])                                 ;WHILE NOT AT BEGINNING OF FIELD
          left                                                                 ;MOVE LEFT TO LAST CHAR OF FIELD
        endwhile
        for i from 1 to fieldlength[counter] ;DEL THE DASHES
          del
        endfor
        switch
          case match(fieldname[counter],"..,..,..:..",typeoffield,nameoffield,wrap,wrapnumber) :
          case match(fieldname[counter],"..,..",typeoffield,nameoffield) :
            switch
              case typeoffield = "DisplayOnly"  : typeoffield = "Regular"
              case typeoffield = "Formula"      : typeoffield = "Calculated"
            endswitch
          otherwise                             : typeoffield = "#Record"
                                                  nameoffield = "Overall"
        endswitch

        menu {field} {place} select typeoffield select nameoffield ;CHOOSE THE FIELD
        enter                                                      ;WHERE FIELD SHOULD BEGIN
        if (wrap = "wrap") then                                    ;IS THIS A WORD WRAPPED FIELD?
          while (colno() > (fieldbegin[counter] + fieldlength[counter]))
            left
          endwhile
        endif
        switch
          case cursorchar() = "A" : while (colno() > ((fieldbegin[counter] + fieldlength[counter]) - 1))
                                      left       ;IN CASE FIELD NOT PLACED ON FORM AT FULL LENGTH
                                    endwhile
                                    enter
                                    if (wrap = "wrap") then
                                      menu {field} {wordwrap} enter ctrlbackspace keypress wrapnumber enter
                                      wrap = ""                           ;"DEASSIGN" THE VARIABLE
                                    endif
          case cursorchar() = "9" : switch
                                      case (fieldname[counter] = "RecordNumber") :
                                        for i from 1 to (fieldlength[counter] - 3)
                                          right
                                        endfor
                                        enter
                                      case (substr(cursorline(),colno() + 1,1) = ")"):  ;IT'S A DOLLAR FIELD
                                        if (fieldlength[counter] > 14) then ;DEFAULTS TO 12 + 2 FOR "()"
                                          enter                             ;PLACE FIELD
                                          enter                             ;FINISH PLACEMENT
                                          right right                       ;GOTO SPACE AFTER ")"
                                        else
                                          while (colno() > (fieldbegin[counter] + fieldlength[counter]) - 1)
                                            left                              ;ADJUST FIELD TO LEFT
                                          endwhile
                                          left left                           ;ACCOUNT FOR 2 PARENTHESES
                                          enter                               ;PLACE DECIMAL POINTS
                                          enter                               ;FINISH PLACING FIELD
                                        endif
                                        i = fieldlength[counter]
                                          switch                             ;COMPLEX STUFF: THE COMMA IN THE DOLLAR FIELD FORCES AN
                                            case (i = 6)  or                 ;  OFFSET SO THAT YOU WON'T HAVE A DOLLAR FIELD LENGTH OF
                                                 (i = 9)  or                 ;  A SEQUENTIAL VALUE.  THUS IN ORDER TO GET CORRECT
                                                 (i = 10) or                 ;  SPACING, i IS COMPUTED WHICH SIGNIFIES THE AMOUNT OF
                                                 (i = 11) or                 ;  SPACES THAT NEED TO BE ADDED TO THE RIGHT OF THE FIELD
                                                 (i = 13) or                 ;  IN ORDER TO MAINTAIN CORRECT SPACING BETWEEN FIELDS.
                                                 (i = 14) or
                                                 (i = 19)    : j = 1
                                            case (i = 8)  or
                                                 (i = 12) or
                                                 (i = 18)    : j = 2
                                            case (i = 3)  or
                                                 (i = 17)    : j = 3
                                            case (i = 16)    : j = 4
                                            case (i = 15)    : j = 5
                                            case (i = 21)    : j = -1
                                            case (i = 22)    : j = -2
                                            case (i = 23)    : j = -3
                                          endswitch
                                        if (j > 0) then
                                          for i from 1 to j
                                            del                              ;BRING RIGHT MARGIN TO THE LEFT
                                          endfor
                                        else
                                          for i from 1 to abs(j)
                                            keypress 32                      ;PUSH RIGHT OVER TO THE RIGHT
                                          endfor
                                        endif
                                      otherwise: if (fieldlength[counter] > 12) then;IF FIELD IS LARGER THAN DEFAULT 12, ADD SPACES
                                                   enter                               ;PLACE FIELD
                                                   right right right                   ;ADD 2 DECIMAL POINTS
                                                   enter                               ;FINISH PLACEMENT
                                                   right                               ;GOTO SPACE AFTER LAST "9"
                                                   while (colno() < (fieldbegin[counter] + fieldlength[counter]))
                                                     keypress 32                       ;ADD SPACES
                                                   endwhile
                                                 else
                                                   while (colno() > (fieldbegin[counter] + fieldlength[counter]) - 1)
                                                     left                            ;ADJUST FIELD TO LEFT
                                                   endwhile
                                                   left left left                    ;BACK 3 MORE FOR 2 DECIMAL PLACES
                                                   enter                             ;PLACE FIELD
                                                   right right right                 ;PLACE 2 DECIMAL PLACE
                                                   enter                             ;FINISH PLACEMENT
                                                 endif
                                    endswitch
          otherwise               : enter                                 ;DATE FIELD
                                    if (colno() < (fieldbegin[counter] + fieldlength[counter])) then
                                      while (colno() < (fieldbegin[counter] + fieldlength[counter]))
                                        keypress 32
                                      endwhile
                                    else
                                      for i from 1 to (colno() - (fieldbegin[counter] + fieldlength[counter]))
                                        del
                                      endfor
                                    endif
        endswitch
        counter = counter - 1                                      ;RUNNING FIELD COUNTER
      endfor
    endif
    ctrlhome                                ;PLACE CURSOR IN FIRST COL
    down                                    ;DOWN TO NEXT LINE
    enter                                   ;OPEN UP NEW BLANK LINE
    up                                      ;GO TO BLANK LINE FOR LINE PLACEMENT
  endfor
  deleteline                                ;DELETE LAST BLANK LINE IN FORM BAND
  menu {setting} {pagelayout} {width} ctrlbackspace typein "80" enter ;RESET COLS BACK TO 80
  for i from 1 to 3
    menu {setting} {pagelayout} {delete} {ok}
  endfor
  do_it!                                    ;SAVE THE PUPPY
endproc

writelib "mainlib" formrept
release procs formrept
;===================================================================================================================================
proc choice1()
 private tablename,fieldname1,fieldname2,fieldname3,continue,pwordvar
  @ 1,1
  text

    Ŀ
                          B R E A K                         
    Ĵ
     DESCRIPTION: BREAK  TAKES  AN  ALPHANUMERIC FIELD THAT 
                  CONTAINS TWO WORDS, SUCH AS A  FIRST  AND 
                  LAST NAME, AND SPLITS THIS FIELD INTO TWO 
                  SEPARATE ALPHANUMERIC FIELDS,  EACH CONT- 
                  AINING ONE OF THE WORDS                   
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF SOURCE FIELD                      
                  NAME OF TARGET FIELD 1                    
                  NAME OF TARGET FIELD 2                    
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
            NAME OF TABLE:                                  
             SOURCE FIELD:                                  
           TARGET FIELD 1:                                  
           TARGET FIELD 2:                                  
    

  endtext
  cursor normal
  style reverse

  verifytable(18,28)                         ;GET TABLE NAME, CHECK FOR EXISTANCE
  if (retval) then                           ;IF USER DIDN'T PRESS [ESC]
    lock tablename FL                        ;PLACE A FULL LOCK ON THE TABLE
    if (retval) then                         ;IF LOCK IN PLACE
      edit tablename
      if (isencrypted(tablename)) then       ;CHECK FOR PASSWORD
        ckpass()
      endif
      if (retval) then                         ;IF USER DIDN'T PRESS [ESC]
        fieldname1 = verifyfield(19,28,"A")    ;GET FIELD NAME, CHECK FOR EXISTANCE AND TYPE
        if (continue) then                     ;IF USER DIDN'T PRESS [ESC]
          fieldname2 = verifyfield(20,28,"A")
          while (fieldname2 = fieldname1)      ;DON'T ALLOW FOR DUP FIELDS
            beep
            wrongans(10)
            fieldname2 = verifyfield(20,28,"A")
          endwhile
          if (continue) then
            fieldname3 = verifyfield(21,28,"A")
            while (fieldname3 = fieldname2)
              beep
              wrongans(10)
              fieldname3 = verifyfield(21,28,"A")
            endwhile
            if (continue) then
              messenger("            Working",0)
              break()
              beep
              messenger("            Done",2)
            endif
          endif
        endif
      endif
      if (isencrypted(tablename)) then    ;IF THE TABLE WAS ENCRYPTED, DECRYPT IT
        unpassword pwordvar               ;NOTE: ! BUG IN PARADOX !  AFTER YOU RETURN TO PARADOX MAIN MENU,
      endif                               ;  YOU MUST VIEW TABLE, THEN CLEARALL AND *THEN* IT'LL BE PROTECTED AGAIN
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice1
release procs choice1
;===================================================================================================================================
proc choice2()
 private tablename,fieldname1,fieldname2,continue,pwordvar
  @ 1,1
  text

    Ŀ
                        D A T E C O N V                     
    Ĵ
     DESCRIPTION: DATECONV  CONVERTS  THE  DATES  IN A DATE 
                  FIELD  TO  THE  FORM  "MONTH 99, 1999" IN 
                  A DIFFERENT ALPHANUMERIC FIELD            
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF DATE FIELD                        
                  NAME OF NEW FIELD                         
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
     NAME OF DATE FIELD:                                    
      NAME OF NEW FIELD:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname1 = verifyfield(20,26,"D")
        if (continue) then
          fieldname2 = verifyfield(21,26,"A")
          if (continue) then
            messenger("         Working",0)
            dateconv()
            beep
            messenger("            Done",2)
          endif
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice2
release procs choice2
;===================================================================================================================================
proc choice3()
 private tablename,fieldname1,fieldname2,continue,pwordvar
  @ 1,1
  text

    Ŀ
                        D O L L A R S                       
    Ĵ
     DESCRIPTION: DOLLARS CONVERTS THE NUMERIC AMOUNT IN  A 
                  DOLLAR FIELD TO ITS FULL  SPELLING  IN  A 
                  DIFFERENT ALPHANUMERIC FIELD, FOR AMOUNTS 
                  UP TO $ 999,999,999.99                    
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF DOLLAR FIELD                      
                  NAME OF SPELLING FIELD                    
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
           DOLLAR FIELD:                                    
         SPELLING FIELD:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname1 = verifyfield(20,26,"$")
        if (continue) then
          fieldname2 = verifyfield(21,26,"A")
          if (continue) then
            messenger("         Working",0)
            dollars()
            beep
            messenger("            Done",2)
          endif
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice3
release procs choice3
;===================================================================================================================================
proc choice4()
 private tablename,fieldname,continue,pwordvar
  @ 1,1
  text

    Ŀ
                        F I R S T U P                       
    Ĵ
     DESCRIPTION: FIRSTUP  TAKES AN  ALPHANUMERIC FIELD AND 
                  CONVERTS THE FIRST CHARACTER OF EACH WORD 
                  TO UPPERCASE,LEAVING ALL OTHER CHARACTERS 
                  INTACT                                    
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF TARGET FIELD                      
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
            NAME OF TABLE:                                  
             TARGET FIELD:                                  
                                                            
    

  endtext
  cursor normal
  style reverse

  verifytable(19,28)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname = verifyfield(20,28,"A")
        if (continue) then
          messenger("         Working",0)
          firstup()
          beep
          messenger("            Done",2)
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice4
release procs choice4
;===================================================================================================================================
proc choice5()
 private tablename,fieldname1,fieldname2,continue,pwordvar
  @ 1,1
  text

    Ŀ
                        F J U L I A N                       
    Ĵ
     DESCRIPTION: FJULIAN CONVERTS A NUMERIC JULIAN DATE TO 
                  ITS  MM/DD/YY FORMAT IN A DIFFERENT FIELD 
                  OF THE STANDARD DATE FORMAT               
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF DATE FIELD                        
                  NAME OF JULIAN FIELD                      
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
            NAME OF TABLE:                                  
     NAME OF JULIAN FIELD:                                  
       NAME OF DATE FIELD:                                  
    

  endtext
  cursor normal
  style reverse

  verifytable(19,28)
  if (retval) then
    lock tablename FL
    if (retval) then
      menu {ask} select tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname1 = verifyfield(20,28,"N")
        if (continue) then
          fieldname2 = verifyfield(21,28,"D")
          if (continue) then
            messenger("         Working",0)
            fjulian()
            beep
            messenger("            Done",2)
          endif
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice5
release procs choice5
;===================================================================================================================================
proc choice6()
 private tablename,formnumber,page,where,formfile
  @ 1,1
  text

    Ŀ
                       F O R M C O P Y                      
    Ĵ
     DESCRIPTION: FORMCOPY COPIES ONE PAGE OF A  FORM  TO A 
                  NEW PAGE                                  
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NUMBER OF FORM                            
                  PAGE OF FORM TO COPY                      
                  COPY BEFORE/AFTER PAGE                    
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
          NAME OF TABLE:                                    
         NUMBER OF FORM:                                    
           PAGE TO COPY:                                    
       (A)FTER-(B)EFORE:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(18,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      menu {forms} {change} select tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        @ 19,26
        accept "A2" picture "{F,#[#]}" required to formnumber
        if (retval) then
          if (formnumber = "F") then
            formfile = tablename + ".F"
          else
            formfile = tablename + ".F" + formnumber
          endif
          while ((numval(formnumber) > 15 or not isfile(formfile)) and (retval))
            beep
            wrongans(5)
            @ 19,26
            accept "A2" picture "{F,#[#]}" required to formnumber
            if (retval) then
              if (formnumber = "F") then
                formfile = tablename + ".F"
              else
                formfile = tablename + ".F" + formnumber
              endif
            endif
          endwhile
          if (retval) then
            wrongans(3)
            @ 20,26
            accept "A2" picture "#[#]" required to page
            if (retval) then
              while ((numval(page) > 15) and (retval))
                beep
                wrongans(5)
                @ 20,26
                accept "A2" picture "#[#]" required to page
              endwhile
              if (retval) then
                wrongans(3)
                @ 21,26
                accept "A6" picture "{After,Before}" required to where
                if (retval) then
                  while ((where = "Before") and (numval(page) = 1) and (retval))
                    beep
                    wrongans(6)
                    @ 21,26
                    accept "A6" picture "{After,Before}" required to where
                  endwhile
                  if (retval) then
                    messenger("                   Working",0)
                    formcopy()
                    beep
                    messenger("                      Done",2)
                  endif
                endif
              endif
            endif
          endif
        endif
        if (not retval) then
          menu
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  cursor off
endproc

writelib "mainlib" choice6
release procs choice6
;===================================================================================================================================
proc choice7()
 private tablename,formnumber,reportnumber,pwordvar
  @ 1,1
  text

    Ŀ
                       F O R M R E P T                      
    Ĵ
     DESCRIPTION: FORMREPT CONVERTS A FORM INTO A FREE-FORM 
                  REPORT                                    
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NUMBER OF FORM                            
                  NUMBER OF REPORT TO COPY TO               
                                                            
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
         NUMBER OF FORM:                                    
       NUMBER OF REPORT:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      menu {forms} {change} select tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        wrongans(3)
        @ 20,26
        accept "A2" picture "#[#]" required to formnumber
        if (retval) then
          formfile = tablename + ".F" + formnumber
          while ((numval(formnumber) > 15 or not isfile(formfile)) and (retval))
            beep
            wrongans(5)
            @ 20,26
            accept "A2" picture "{F,#[#]}" required to formnumber
            if (retval) then
              formfile = tablename + ".F" + formnumber
            endif
          endwhile
          if (retval) then
            wrongans(3)
            @ 21,26
            accept "A2" picture "#[#]" required to reportnumber
            if (retval) then
              reportfile = tablename + ".R" + reportnumber
              while ((numval(reportnumber) > 15 or isfile(reportfile)) and (retval))
                beep
                if (numval(reportnumber) > 15) then
                  wrongans(5)
                else
                  wrongans(11)
                endif
                @ 21,26
                accept "A2" picture "{R,#[#]}" required to reportnumber
                if (retval) then
                  reportfile = tablename + ".R" + reportnumber
                endif
              endwhile
              if (retval) then
                messenger("         Working",0)
                formrept()
                beep
                messenger("            Done",2)
              endif
            endif
          endif
        endif
        if (not retval) then
          menu
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  cursor off
endproc

writelib "mainlib" choice7
release procs choice7
;===================================================================================================================================
proc choice8()
 private tablename,fieldname,oldvalue,newvalue,continue,pwordvar
  @ 1,1
  text

    Ŀ
                       G R E P L A C E                      
    Ĵ
     DESCRIPTION: GREPLACE DOES A  GLOBAL  REPLACE  OF  ANY 
                  STRING  IN  AN ALPHANUMERIC  FIELD WITH A 
                  NEW STRING                                
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF TARGET FIELD                      
                  STRING TO SEARCH FOR                      
                  REPLACEMENT STRING                        
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
          NAME OF TABLE:                                    
           TARGET FIELD:                                    
          SEARCH STRING:                                    
     REPLACEMENT STRING:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(18,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname = verifyfield(19,26,"A")
        if (continue) then
          @ 20,26
          accept "A34" required to oldvalue
          if (retval) then
            @ 21,26
            accept "A34" required to newvalue
            if (retval) then
              messenger("         Working",0)
              greplace()
              beep
              messenger("            Done",2)
            endif
          endif
          if (sysmode() = "Edit") then
            canceledit
          endif
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice8
release procs choice8
;===================================================================================================================================
proc choice9()
 private tablename,fieldname,startnum,incrementor,continue,pwordvar
  @ 1,1
  text

    Ŀ
                          I N C N U M                       
    Ĵ
     DESCRIPTION: INCNUM  INCREMENTS  AN  ALPHANNUMERIC  OR 
                  NUMERIC FIELD BY A GIVEN AMOUNT           
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF TARGET FIELD                      
                  NUMBER TO START COUNTING FROM             
                  NUMBER TO INCREMENT COUNTER BY            
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
          NAME OF TABLE:                                    
           TARGET FIELD:                                    
        STARTING NUMBER:                                    
       INCREMENT NUMBER:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(18,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname = verifytwofields(19,26,"A","N")
        if (continue) then
          @ 20,26
          accept "N" required to startnum
          if (retval) then
            @ 21,26
            accept "N" required to incrementor
            if (retval) then
              messenger("         Working",0)
              incnum()
              beep
              messenger("            Done",2)
            endif
          endif
          if (not retval) then              ;THESE 2 FIELDS NOT COVERED BY VERIFYFIELD(), THUS MUST CHECK FOR CANCEL HERE
            canceledit
          endif
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice9
release procs choice9
;===================================================================================================================================
proc choice10()
 private tablename,recnum,times,before,pwordvar
  @ 1,1
  text

    Ŀ
                          I N S R E C                       
    Ĵ
     DESCRIPTION: INSREC INSERTS A RECORD A SPECIFIC NUMBER 
                  OF TIMES BEFORE ANOTHER RECORD IN A  NON- 
                  KEYED TABLE                               
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NUMBER OF RECORD TO COPY                  
                  NUMBER OF TIMES TO COPY THE RECORD        
                  RECORD TO INSERT BEFORE                   
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
          NAME OF TABLE:                                    
          RECORD NUMBER:                                    
          TIMES TO COPY:                                    
        INSERTION POINT:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(18,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
         @ 19,26
        accept "N" required to recnum
        if (retval) then
          while ((recnum > nrecords(tablename)) and (retval)) ;WHILE THE RECORD THEY SPECIFY IS
            beep                                                     ;  GREATER THAN # REC'S IN TABLE
            wrongans(5)
            @ 19,26
            accept "N" required to recnum
          endwhile
          if (retval) then
            wrongans(3)
            @ 20,26
            accept "N" required to times       ;GET NUMBER OF TIMES TO COPY
            if (retval) then
              @ 21,26
              accept "N" required to before
              if (retval) then
                messenger("         Working",0)
                insrec(tablename,recnum,times,before)
                beep
                messenger("              Done",2)
              endif
            endif
          endif
          if (not retval) then
            canceledit
          endif
        endif
        if (isencrypted(tablename)) then
          unpassword pwordvar
        endif
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice10
release procs choice10
;====================================================================================================================================
proc choice11()
 private tablename,fieldname,continue,pwordvar
  @ 1,1
  text

    Ŀ
                       L A S T D O W N                      
    Ĵ
     DESCRIPTION: LASTDOWN CONVERTS THE FIRST CHARACTER  OF 
                  EACH WORD IN AN ALPHANUERIC FIELD TO UPPER
                  CASE AND THE REMAINING CHARACTERS TO LOWER
                  CASE                                      
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF FIELD                             
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
          NAME OF FIELD:                                    
                                                            
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname = verifyfield(20,26,"A")
        if (continue) then
          messenger("         Working",0)
          lastdown()
          beep
          messenger("            Done",2)
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice11
release procs choice11
;===================================================================================================================================
proc choice12()
 private tablename,fieldname,continue,pwordvar
  @ 1,1
  text

    Ŀ
                         L O W C A S E                      
    Ĵ
     DESCRIPTION: LOWCASE CONVERTS ALL THE CHARACTERS IN AN 
                  ALPHANUMERIC FIELD TO LOWER CASE          
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF FIELD                             
                                                            
                                                            
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
          NAME OF FIELD:                                    
                                                            
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname = verifyfield(20,26,"A")
        if (continue) then
          messenger("         Working",0)
          lowcase()
          beep
          messenger("            Done",2)
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc


writelib "mainlib" choice12
release procs choice12
;===================================================================================================================================
proc choice13()
 private tablename,beginrec,endrec,pwordvar
  @ 1,1
  text

    Ŀ
                            Q N U M                         
    Ĵ
     DESCRIPTION: QNUM  QUERIES  OUT  RECORDS  FROM A TABLE 
                  BASED ON A BEGINNING RECORD NUMBER  AND A 
                  ENDING  RECORD NUMBER  AND  PLACES  THESE 
                  RECORDS IN AN "ANSWER" TABLE.             
                                                            
     REQUIRED:    NAME OF TABLE                             
                  BEGINNING RECORD NUMBER                   
                  ENDING RECORD NUMBER                      
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
       BEGINNING RECORD:                                    
          ENDING RECORD:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      view tablename                        ;PLACED IN EDIT IN QNUM()
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        @ 20,26
        accept "N" required to beginrec
        if (retval) then
          while ((beginrec > nrecords(tablename)) and (retval))
            beep
            wrongans(5)
            @ 20,26
            accept "N" required to beginrec
          endwhile
          if (retval) then
            wrongans(3)
            @ 21,26
            accept "N" required to endrec
            if (retval) then
              while ((endrec > nrecords(tablename)) and (endrec < beginrec) and (retval))
                beep
                wrongans(5)
                @ 21,26
                accept "N" required to endrec
              endwhile
              if (retval) then
                wrongans(3)
                messenger("         Working",0)
                qnum()
                beep
                messenger("            Done",2)
              endif
            endif
          endif
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice13
release procs choice13
;===================================================================================================================================
proc choice14()
 private tablename
  @ 1,1
  text

    Ŀ
                        R E C S I Z E                       
    Ĵ
     DESCRIPTION: RECSIZE COMPUTES THE RECORD  SIZE  OF THE 
                  SPECIFIED TABLE.                          
                                                            
     REQUIRED:    NAME OF TABLE                             
                                                            
                                                            
                                                            
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
                                                            
                                                            
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      menu {tools} {info} {structure} select tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        messenger("         Working",0)
        beep
        messenger (("Record size is " + strval(recsize())) + " bytes",2)
        messenger("                     Done",2)
      else
        menu                                ;GET PDOX MAIN MENU
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice14
release procs choice14
;===================================================================================================================================
proc choice15()
 private tablename,fieldname1,fieldname2,continue,pwordvar
  @ 1,1
  text

    Ŀ
                       S T A T E A B V                      
    Ĵ
     DESCRIPTION: STATEABV CONVERTS A STATE'S FULL SPELLING 
                  TO ITS ABBREVIATION IN A DIFFERENT  FIELD 
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF STATE FIELD                       
                  NAME OF ABBREVIATED FIELD                 
                                                            
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
            STATE FIELD:                                    
      ABBREVIATED FIELD:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname1 = verifyfield(20,26,"A")
        if (continue) then
          fieldname2 = verifyfield(21,26,"A")
          while (fieldname2 = fieldname1)
            beep
            wrongans(10)
            fieldname2 = verifyfield(21,26,"A")
          endwhile
          if (continue) then
            messenger("         Working",0)
            stateabv()
            beep
            messenger("            Done",2)
          endif
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice15
release procs choice15
;===================================================================================================================================\
proc choice16()
 private tablename,fieldname1,fieldname2,continue,pwordvar
  @ 1,1
  text

    Ŀ
                       S T A T E F U L                      
    Ĵ
     DESCRIPTION: STATEABV CONVERTS A STATE'S  ABBREVIATION 
                  TO ITS FULL SPELLING IN A DIFFERENT FIELD 
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF STATE FIELD                       
                  NAME OF ABBREVIATED FIELD                 
                                                            
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
            STATE FIELD:                                    
      ABBREVIATED FIELD:                                    
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname1 = verifyfield(20,26,"A")
        if (continue) then
          fieldname2 = verifyfield(21,26,"A")
          while (fieldname2 = fieldname1)
            beep
            wrongans(10)
            fieldname2 = verifyfield(21,26,"A")
          endwhile
          if (continue) then
            messenger("         Working",0)
            stateful()
            beep
            messenger("            Done",2)
          endif
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc


writelib "mainlib" choice16
release procs choice16
;===================================================================================================================================
proc choice17()
 private tablename,fieldname1,fieldname2,continue,pwordvar
  @ 1,1
  text

    Ŀ
                        T J U L I A N                       
    Ĵ
     DESCRIPTION: TJULIAN CONVERTS A DATE FROM ITS MM/DD/YY 
                  FORMAT TO ITS JULIAN EQUIVALENT IN A DIF- 
                  FERENT NUMERIC FIELD                      
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF DATE FIELD                        
                  NAME OF JULIAN FIELD                      
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
            NAME OF TABLE:                                  
       NAME OF DATE FIELD:                                  
     NAME OF JULIAN FIELD:                                  
    

  endtext
  cursor normal
  style reverse

  verifytable(19,28)
  if (retval) then
    lock tablename FL
    if (retval) then
      menu {ask} select tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname1 = verifyfield(20,28,"D")
        if (continue) then
          fieldname2 = verifyfield(21,28,"N")
          if (continue) then
            messenger("         Working",0)
            tjulian()
            beep
            messenger("            Done",2)
          endif
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice17
release procs choice17
;===================================================================================================================================
proc choice18()
 private tablename,fieldname
  @ 1,1
  text

    Ŀ
                          U P C A S E                       
    Ĵ
     DESCRIPTION: UPCASE CONVERTS ALL THE CHARACTERS IN  AN 
                  ALPHANUMERIC FIELD TO UPPER CASE          
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF FIELD                             
                                                            
                                                            
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
          NAME OF FIELD:                                    
                                                            
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname = verifyfield(20,26,"A")
        if (continue) then
          messenger("         Working",0)
          upcase()
          beep
          messenger("            Done",2)
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice18
release procs choice18
;===================================================================================================================================
proc choice19()
 private tablename,fieldname
  @ 1,1
  text

    Ŀ
                         W S W I T C H                      
    Ĵ
     DESCRIPTION: WSWITCH TAKES AN ALPHANUMERIC FIELD  THAT 
                  CONTAINS  TWO  WORDS  AND  SWITCHES THEIR 
                  ORDER                                     
                                                            
     REQUIRED:    NAME OF TABLE                             
                  NAME OF FIELD                             
                                                            
                                                            
                                                            
                                                            
    Ĵ
     PLEASE ENTER THE NECESSARY INFORMATION, [ESC] TO EXIT: 
              * BEEP WILL SOUND FOR INVALID DATA *          
                                                            
          NAME OF TABLE:                                    
          NAME OF FIELD:                                    
                                                            
    

  endtext
  cursor normal
  style reverse

  verifytable(19,26)
  if (retval) then
    lock tablename FL
    if (retval) then
      edit tablename
      if (isencrypted(tablename)) then
        ckpass()
      endif
      if (retval) then
        fieldname = verifyfield(20,26,"A")
        if (continue) then
          messenger("         Working",0)
          wswitch()
          beep
          messenger("            Done",2)
        endif
      endif
      if (isencrypted(tablename)) then
        unpassword pwordvar
      endif
    else
      beep
      messenger("Unable to lock table",2)
    endif
  endif
  clearall
  cursor off
endproc

writelib "mainlib" choice19
release procs choice19
;===================================================================================================================================
